# IF
# Task1.1: Если значение некой переменной больше 0, выводилось бы специальное
# сообщение. Один раз выполните программу при значении переменной больше 0,
# второй раз — меньше 0.
a = 4
if a > 0:
    print('Task 1.1: A is greater than 0')

# Task1.2: Усовершенствуйте предыдущий код с помощью ветки else так, чтобы в
# зависимости от значения переменной, выводилась либо 1, либо -1.
b = -5
if b > 0:
    print('Task 1.2: 1')
else:
    print('Task 1.2: -1')

# Task1.3: Самостоятельно придумайте программу, в которой бы использовалась
# инструкция if (желательно с веткой elif). Вложенный код должен содержать не
# менее трех выражений.
c = 66
d = 15
if c == 60:
    c += 1
    d = c + d
    print('Task 1.3:', d)
elif c == 66:
    c = c + 44
    d = -1
    print('Task 1.3:', c * d)
else:
    print('Task 1.3: Nothing has been made with c')

# ELIF
# Task2.1: Напишите программу по следующему описанию:
# a. двум переменным присваиваются числовые значения
# b. если значение первой переменной больше второй - найти разницу значений
# переменных (вычесть из первой вторую), результат связать с третьей
# переменной
# c. если первая переменная имеет меньшее значение, чем вторая, то третью
# переменную связать с результатом суммы значений двух первых переменных
# d. во всех остальных случаях, присвоить третьей переменной значение первой
# переменной;
# e. вывести значение третьей переменной на экран.
a1 = 7
a2 = 7
if a1 > a2:
    c1 = a1 - a2
elif a1 < a2:
    c1 = a1 + a2
else:
    c1 = a1
print('Task 2.1:', c1)

# Task2.2: Придумайте программу, в которой бы использовалась инструкция
# if-elif-else.Количество ветвей должно быть как минимум четыре.
age = 100
if 100 > age >= 18:
    print("Task 2.2: Вы наверное учитесь или уже окончили ВУЗ!")
elif 18 > age >= 16:
    print('Task 2.2: Вы только окончили школу!')
elif 16 > age > 12:
    print('Task 2.2: Вы в средней школе!')
else:
    print('Task 2.2: Вы либо очень маленький, либо очень-очень взрослый чтобы'
          ' учиться!')

# FOR
# Task3.1 Создайте список, состоящий из четырех строк. Затем,с помощью цикла
# for, выведите строки поочередно на экран.
lst = ['test1', 'test2', 'test3', 'test4']
print('Task 3.1:')
for i in lst:
    print(i)

# Task3.2: Измените пред. программу так, чтобы в конце каждой буквы строки
# добавлялось тире. (Подсказка: цикл for может быть вложен в другой цикл.)
lst = ['test1', 'test2', 'test3', 'test4']
print('Task 3.2:')
for i in lst:
    for k in i:
        print(k + '-')

# Task3.3: Создайте список, содержащий элементы целочисленного типа, затем с
# помощью цикла перебора измените тип данных элементов на числа с плавающей
# точкой. (Подсказка: используйте встроенную функцию float().)
lst2 = [1, 2, 3, 4]
print('Task 3.3:')
for i in lst2:
    print(float(i))

# Task3.4: Есть два списка с одинаковым количеством элементов, в каждом из них
# этих списков есть элемент “hello”. В первом списке индекс этого элемента 1,
# во втором 7. Одинаковых элементов в обоих списках может быть несколько.
# Напишите программу которая распечатает индекс слова “hello” в первом списке и
# условный номер списка, индекс слова во втором списки и условный номер списка
# со словом Совпадают. Например, программа выведет на экран:
# “Совпадают 1-й элемент из первого списка и 7-й элемент из второго списка”
lst3 = ['hi', 'hello', 'tree', 'book', 'this', 'blue', 'glo', 'no']
lst4 = ['ri', 'yes', 'no', 'took', 'his', 'lue', 'go', 'hello']
for i in lst3:
    for j in lst4:
        if i == j:
            ind_1st = lst3.index(i)
            ind_2nd = lst4.index(j)
            print('Task 3.4: Совпадают ' + str(ind_1st) + '-й элемент из '
                  'первого списка и ' + str(ind_2nd) + '-й из второго списка')

# WHILE
# Task 4.1. Напишите скрипт на языке программирования Python, выводящий ряд
# чисел Фибоначчи (числовая последоватьность в которой числа начинаются с 1 и 1
# или же и 0 и 1, пример: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233,
# ...). Запустите его на выполнение. Затем измените код так, чтобы выводился
# ряд чисел Фибоначчи, начиная с пятого члена ряда и заканчивая двадцатым.
first_elem = 0
second_elem = 1
show_results = [str(first_elem), str(second_elem)]
im = 20
while im > 0:
    next_elem = first_elem + second_elem
    show_results.append(str(next_elem))
    first_elem = second_elem
    second_elem = next_elem
    im -= 1
print('Task 4.1:', show_results)
print('Task 4.1(5-20):', show_results[4:20])

# Task 4.2. Напишите цикл, выводящий ряд четных чисел от 0 до 20. Затем,
# каждое третье число в ряде от -1 до -21.
p = 0
p2 = ''
while p < 21:
    if p % 2 == 0:
        p2 = p2 + str(p) + ' '
    p += 1
print('Task 4.2:', p2)

i = -3
p3 = ''
while i > -22:
    p3 = p3 + str(i) + ' '
    i -= 3
print('Task 4.2:', p3)

# Task 4.3 Самостоятельно придумайте программу на Python, в которой бы
# использовался цикл while. В комментарии опишите что она делает. =>
# Банкомат выдает купюры номиналом 5, 10, 20, 50 бел. руб. Определить какое
# минимальное кол-во купюр может вернуть банкомат после введенной суммы
i = 0
amount = int(input('Task 4.3: Введите желаемую сумму: '))
if amount % 5 == 0:
    ost = amount
    while ost >= 50:
        ost = ost - 50
        i += 1
    while 20 <= ost < 50:
        ost = ost - 20
        i += 1
    while 10 <= ost < 20:
        ost = ost - 10
        i += 1
    while 5 <= ost < 10:
        ost = ost - 5
        i += 1
    print('Task 4.3: Минимальное кол-во купюр', i)
else:
    print('Task 4.3: Вы ввели неверную сумму!')


# Input
# Task5.1: Напишите программу, которая запрашивает у пользователя:
# - его имя (например, "What is your name?")
# - возраст ("How old are you?")
# - место жительства ("Where are you live?")
# После этого выводила бы три строки:
# "This is имя"
# "It is возраст"
# "(S)he lives in место_жительства"
name = input('Task 5.1: What is your name? ')
age = input('Task 5.1: How old are you? ')
place = input('Task 5.1: Where are you live? ')
print('Task 5.1: This is', name)
print('Task 5.1: It is', age)
print('Task 5.1: (S)he lives in', place)

# Task5.2: Напишите программу, которая предлагала бы пользователю решить
# пример 4 * 100 - 54. Потом выводила бы на экран правильный ответ и ответ
# пользователя. Подумайте, нужно ли здесь преобразовывать строку в число.
answer = input('Task 5.2: Напишите результат выражения 4 * 100 - 54: ')
if answer.isdigit() and int(answer) == 4 * 100 - 54:
    print('Task 5.2: Вы правы!')
else:
    print('Task 5.2: Подумайте еще!')
# посколько инпут это строка нужно преобразовывать ее в число для сравнения с
# правильным результатом.

# Task5.3: Запросите у пользователя четыре числа. Отдельно сложите первые два и
# отдельно вторые два. Разделите первую сумму на вторую. Выведите результат на
# экран так, чтобы ответ содержал две цифры после запятой.
dig1 = 0
dig2 = 0
for i in range(4):
    if i < 2:
        dig = int(input(f'Введите число {i + 1} : '))
        dig1 += dig
    else:
        dig = int(input(f'Введите число {i + 1} : '))
        dig2 += dig
print("%.2f" % (dig1 / dig2))
